Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12928)
@@ -718,27 +690,25 @@
           IF ( iom_use("ghamv_00") ) CALL iom_put( "ghamv_00", wmask*ghamv )
        END IF
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( lconv(ji,jj) ) THEN
-                DO jk = 2, imld(ji,jj)
-                   zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) +      ( -0.05 * EXP ( -0.4 * zznd_d )   * zsc_uw_1(ji,jj)   &
-                        &          +                        0.00125 * EXP (      - zznd_d )   * zsc_uw_2(ji,jj) ) &
-                        &          *                          ( 1.0 - EXP ( -2.0 * zznd_d ) )
+       DO_2D_00_00
+          IF ( lconv(ji,jj) ) THEN
+             DO jk = 2, imld(ji,jj)
+                zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) +      ( -0.05 * EXP ( -0.4 * zznd_d )   * zsc_uw_1(ji,jj)   &
+                     &          +                        0.00125 * EXP (      - zznd_d )   * zsc_uw_2(ji,jj) ) &
+                     &          *                          ( 1.0 - EXP ( -2.0 * zznd_d ) )
 !
-                   ghamv(ji,jj,jk) = ghamv(ji,jj,jk) - 0.65 *  0.15 * EXP (      - zznd_d )                       &
-                        &          *                          ( 1.0 - EXP ( -2.0 * zznd_d ) ) * zsc_vw_1(ji,jj)
-                END DO   ! end jk loop
-             ELSE
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) - 0.65 *  0.15 * EXP (      - zznd_d )                       &
+                     &          *                          ( 1.0 - EXP ( -2.0 * zznd_d ) ) * zsc_vw_1(ji,jj)
+             END DO   ! end jk loop
+          ELSE
 ! Stable conditions
-                DO jk = 2, ibld(ji,jj) ! corrected to ibld
-                   zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) - 0.75 *   1.3 * EXP ( -0.5 * zznd_d )                       &
-                        &                                   * ( 1.0 - EXP ( -4.0 * zznd_d ) ) * zsc_uw_1(ji,jj)
-                   ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + 0._wp
-                END DO   ! end jk loop
-             ENDIF
-          END DO  ! ji loop
-       END DO     ! jj loo
+             DO jk = 2, ibld(ji,jj) ! corrected to ibld
+                zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) - 0.75 *   1.3 * EXP ( -0.5 * zznd_d )                       &
+                     &                                   * ( 1.0 - EXP ( -4.0 * zznd_d ) ) * zsc_uw_1(ji,jj)
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + 0._wp
+             END DO   ! end jk loop
+          ENDIF
+       END_2D
 
 ! Buoyancy term in flux-gradient relationship [note : includes ROI ratio (X0.3) and pressure (X0.5)]
@@ -752,27 +722,25 @@
        ENDWHERE
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF (lconv(ji,jj) ) THEN
-                DO jk = 2, imld(ji,jj)
-                   zznd_ml = gdepw_n(ji,jj,jk) / zhml(ji,jj)
-                   ! calculate turbulent length scale
-                   zl_c = 0.9 * ( 1.0 - EXP ( - 7.0 * ( zznd_ml - zznd_ml**3 / 3.0 ) ) )                                           &
-                        &     * ( 1.0 - EXP ( -15.0 * (     1.1 - zznd_ml          ) ) )
-                   zl_l = 2.0 * ( 1.0 - EXP ( - 2.0 * ( zznd_ml - zznd_ml**3 / 3.0 ) ) )                                           &
-                        &     * ( 1.0 - EXP ( - 5.0 * (     1.0 - zznd_ml          ) ) ) * ( 1.0 + dstokes(ji,jj) / zhml (ji,jj) )
-                   zl_eps = zl_l + ( zl_c - zl_l ) / ( 1.0 + EXP ( -3.0 * LOG10 ( - zhol(ji,jj) ) ) ) ** (3.0/2.0)
-                   ! non-gradient buoyancy terms
-                   ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * 0.5 * zsc_wth_1(ji,jj) * zl_eps * zhml(ji,jj) / ( 0.15 + zznd_ml )
-                   ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * 0.5 *  zsc_ws_1(ji,jj) * zl_eps * zhml(ji,jj) / ( 0.15 + zznd_ml )
-                END DO
-             ELSE
-                DO jk = 2, ibld(ji,jj)
-                   ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zsc_wth_1(ji,jj)
-                   ghams(ji,jj,jk) = ghams(ji,jj,jk) +  zsc_ws_1(ji,jj)
-                END DO
-             ENDIF
-          END DO   ! ji loop
-       END DO      ! jj loop
+       DO_2D_00_00
+          IF (lconv(ji,jj) ) THEN
+             DO jk = 2, imld(ji,jj)
+                zznd_ml = gdepw(ji,jj,jk,Kmm) / zhml(ji,jj)
+                ! calculate turbulent length scale
+                zl_c = 0.9 * ( 1.0 - EXP ( - 7.0 * ( zznd_ml - zznd_ml**3 / 3.0 ) ) )                                           &
+                   &     * ( 1.0 - EXP ( -15.0 * (     1.1 - zznd_ml          ) ) )
+                zl_l = 2.0 * ( 1.0 - EXP ( - 2.0 * ( zznd_ml - zznd_ml**3 / 3.0 ) ) )                                           &
+                   &     * ( 1.0 - EXP ( - 5.0 * (     1.0 - zznd_ml          ) ) ) * ( 1.0 + dstokes(ji,jj) / zhml (ji,jj) )
+                zl_eps = zl_l + ( zl_c - zl_l ) / ( 1.0 + EXP ( -3.0 * LOG10 ( - zhol(ji,jj) ) ) ) ** (3.0/2.0)
+                ! non-gradient buoyancy terms
+                ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * 0.5 * zsc_wth_1(ji,jj) * zl_eps * zhml(ji,jj) / ( 0.15 + zznd_ml )
+                ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * 0.5 *  zsc_ws_1(ji,jj) * zl_eps * zhml(ji,jj) / ( 0.15 + zznd_ml )
+             END DO
+          ELSE
+             DO jk = 2, ibld(ji,jj)
+                ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zsc_wth_1(ji,jj)
+                ghams(ji,jj,jk) = ghams(ji,jj,jk) +  zsc_ws_1(ji,jj)
+             END DO
+          ENDIF
+       END_2D
 
        WHERE ( lconv )
@@ -785,23 +753,21 @@
        ENDWHERE
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( lconv(ji,jj) ) THEN
-                DO jk = 2 , imld(ji,jj)
-                   zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.3 * 0.5 * ( zsc_uw_1(ji,jj) +   0.125 * EXP( -0.5 * zznd_d )     &
-                        &                                                            * (   1.0 - EXP( -0.5 * zznd_d ) )   &
-                        &                                          * zsc_uw_2(ji,jj)                                    )
-                   ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
-                END DO  ! jk loop
-             ELSE
-             ! stable conditions
-                DO jk = 2, ibld(ji,jj)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zsc_uw_1(ji,jj)
-                   ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
-                END DO
-             ENDIF
-          END DO        ! ji loop
-       END DO           ! jj loop
+       DO_2D_00_00
+          IF ( lconv(ji,jj) ) THEN
+             DO jk = 2 , imld(ji,jj)
+                zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.3 * 0.5 * ( zsc_uw_1(ji,jj) +   0.125 * EXP( -0.5 * zznd_d )     &
+                     &                                                            * (   1.0 - EXP( -0.5 * zznd_d ) )   &
+                     &                                          * zsc_uw_2(ji,jj)                                    )
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
+             END DO  ! jk loop
+          ELSE
+          ! stable conditions
+             DO jk = 2, ibld(ji,jj)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zsc_uw_1(ji,jj)
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
+             END DO
+          ENDIF
+       END_2D
 
        IF(ln_dia_osm) THEN
@@ -819,31 +785,29 @@
        ENDWHERE
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-            IF ( lconv(ji,jj) ) THEN
-               DO jk = 2, imld(ji,jj)
-                  zznd_ml=gdepw_n(ji,jj,jk) / zhml(ji,jj)
-                  ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * zsc_wth_1(ji,jj)                &
-                       &          * ( -2.0 + 2.75 * (       ( 1.0 + 0.6 * zznd_ml**4 )      &
-                       &                               - EXP(     - 6.0 * zznd_ml    ) ) )  &
-                       &          * ( 1.0 - EXP( - 15.0 * (         1.0 - zznd_ml    ) ) )
-                  !
-                  ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * zsc_ws_1(ji,jj)  &
-                       &          * ( -2.0 + 2.75 * (       ( 1.0 + 0.6 * zznd_ml**4 )      &
-                       &                               - EXP(     - 6.0 * zznd_ml    ) ) )  &
-                       &          * ( 1.0 - EXP ( -15.0 * (         1.0 - zznd_ml    ) ) )
-               END DO
-            ELSE
-               DO jk = 2, ibld(ji,jj)
-                  zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                  znd = gdepw_n(ji,jj,jk) / zhbl(ji,jj)
-                  ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * ( -4.06 * EXP( -2.0 * zznd_d ) * (1.0 - EXP( -4.0 * zznd_d ) ) + &
-               &  7.5 * EXP ( -10.0 * ( 0.95 - znd )**2 ) * ( 1.0 - znd ) ) * zsc_wth_1(ji,jj)
-                  ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * ( -4.06 * EXP( -2.0 * zznd_d ) * (1.0 - EXP( -4.0 * zznd_d ) ) + &
-               &  7.5 * EXP ( -10.0 * ( 0.95 - znd )**2 ) * ( 1.0 - znd ) ) * zsc_ws_1(ji,jj)
-               END DO
-            ENDIF
-          ENDDO    ! ji loop
-       END DO      ! jj loop
+       DO_2D_00_00
+         IF ( lconv(ji,jj) ) THEN
+            DO jk = 2, imld(ji,jj)
+               zznd_ml=gdepw(ji,jj,jk,Kmm) / zhml(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * zsc_wth_1(ji,jj)                &
+                    &          * ( -2.0 + 2.75 * (       ( 1.0 + 0.6 * zznd_ml**4 )      &
+                    &                               - EXP(     - 6.0 * zznd_ml    ) ) )  &
+                    &          * ( 1.0 - EXP( - 15.0 * (         1.0 - zznd_ml    ) ) )
+               !
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * zsc_ws_1(ji,jj)  &
+                    &          * ( -2.0 + 2.75 * (       ( 1.0 + 0.6 * zznd_ml**4 )      &
+                    &                               - EXP(     - 6.0 * zznd_ml    ) ) )  &
+                    &          * ( 1.0 - EXP ( -15.0 * (         1.0 - zznd_ml    ) ) )
+            END DO
+         ELSE
+            DO jk = 2, ibld(ji,jj)
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               znd = gdepw(ji,jj,jk,Kmm) / zhbl(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3 * ( -4.06 * EXP( -2.0 * zznd_d ) * (1.0 - EXP( -4.0 * zznd_d ) ) + &
+            &  7.5 * EXP ( -10.0 * ( 0.95 - znd )**2 ) * ( 1.0 - znd ) ) * zsc_wth_1(ji,jj)
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3 * ( -4.06 * EXP( -2.0 * zznd_d ) * (1.0 - EXP( -4.0 * zznd_d ) ) + &
+            &  7.5 * EXP ( -10.0 * ( 0.95 - znd )**2 ) * ( 1.0 - znd ) ) * zsc_ws_1(ji,jj)
+            END DO
+         ENDIF
+       END_2D
 
        WHERE ( lconv )
@@ -857,38 +821,36 @@
        ENDWHERE
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( lconv(ji,jj) ) THEN
-               DO jk = 2, imld(ji,jj)
-                  zznd_ml = gdepw_n(ji,jj,jk) / zhml(ji,jj)
-                  zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
+       DO_2D_00_00
+          IF ( lconv(ji,jj) ) THEN
+            DO jk = 2, imld(ji,jj)
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / zhml(ji,jj)
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk)&
+                    & + 0.3 * ( -2.0 + 2.5 * ( 1.0 + 0.1 * zznd_ml**4 ) - EXP ( -8.0 * zznd_ml ) ) * zsc_uw_1(ji,jj)
+               !
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
+                    & + 0.3 * 0.1 * ( EXP( -zznd_d ) + EXP( -5.0 * ( 1.0 - zznd_ml ) ) ) * zsc_vw_1(ji,jj)
+            END DO
+          ELSE
+            DO jk = 2, ibld(ji,jj)
+               znd = gdepw(ji,jj,jk,Kmm) / zhbl(ji,jj)
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               IF ( zznd_d <= 2.0 ) THEN
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.5 * 0.3 &
+                       &*  ( 2.25 - 3.0  * ( 1.0 - EXP( - 1.25 * zznd_d ) ) * ( 1.0 - EXP( -2.0 * zznd_d ) ) ) * zsc_uw_1(ji,jj)
+                  !
+               ELSE
                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk)&
-                       & + 0.3 * ( -2.0 + 2.5 * ( 1.0 + 0.1 * zznd_ml**4 ) - EXP ( -8.0 * zznd_ml ) ) * zsc_uw_1(ji,jj)
+                       & + 0.5 * 0.3 * ( 1.0 - EXP( -5.0 * ( 1.0 - znd ) ) ) * zsc_uw_2(ji,jj)
                   !
-                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
-                       & + 0.3 * 0.1 * ( EXP( -zznd_d ) + EXP( -5.0 * ( 1.0 - zznd_ml ) ) ) * zsc_vw_1(ji,jj)
-               END DO
-             ELSE
-               DO jk = 2, ibld(ji,jj)
-                  znd = gdepw_n(ji,jj,jk) / zhbl(ji,jj)
-                  zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                  IF ( zznd_d <= 2.0 ) THEN
-                     ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.5 * 0.3 &
-                          &*  ( 2.25 - 3.0  * ( 1.0 - EXP( - 1.25 * zznd_d ) ) * ( 1.0 - EXP( -2.0 * zznd_d ) ) ) * zsc_uw_1(ji,jj)
-                     !
-                  ELSE
-                     ghamu(ji,jj,jk) = ghamu(ji,jj,jk)&
-                          & + 0.5 * 0.3 * ( 1.0 - EXP( -5.0 * ( 1.0 - znd ) ) ) * zsc_uw_2(ji,jj)
-                     !
-                  ENDIF
-
-                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
-                       & + 0.3 * 0.15 * SIN( 3.14159 * ( 0.65 * zznd_d ) ) * EXP( -0.25 * zznd_d**2 ) * zsc_vw_1(ji,jj)
-                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
-                       & + 0.3 * 0.15 * EXP( -5.0 * ( 1.0 - znd ) ) * ( 1.0 - EXP( -20.0 * ( 1.0 - znd ) ) ) * zsc_vw_2(ji,jj)
-               END DO
-             ENDIF
-          END DO
-       END DO
+               ENDIF
+
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
+                    & + 0.3 * 0.15 * SIN( 3.14159 * ( 0.65 * zznd_d ) ) * EXP( -0.25 * zznd_d**2 ) * zsc_vw_1(ji,jj)
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk)&
+                    & + 0.3 * 0.15 * EXP( -5.0 * ( 1.0 - znd ) ) * ( 1.0 - EXP( -20.0 * ( 1.0 - znd ) ) ) * zsc_vw_2(ji,jj)
+            END DO
+          ENDIF
+       END_2D
 
        IF(ln_dia_osm) THEN
@@ -903,31 +865,29 @@
 ! Make surface forced velocity non-gradient terms go to zero at the base of the mixed layer.
 
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            IF ( lconv(ji,jj) ) THEN
-               DO jk = 2, ibld(ji,jj)
-                  znd = ( gdepw_n(ji,jj,jk) - zhml(ji,jj) ) / zhml(ji,jj) !ALMG to think about
-                  IF ( znd >= 0.0 ) THEN
-                     ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * ( 1.0 - EXP( -30.0 * znd**2 ) )
-                     ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * ( 1.0 - EXP( -30.0 * znd**2 ) )
-                  ELSE
-                     ghamu(ji,jj,jk) = 0._wp
-                     ghamv(ji,jj,jk) = 0._wp
-                  ENDIF
-               END DO
-            ELSE
-               DO jk = 2, ibld(ji,jj)
-                  znd = ( gdepw_n(ji,jj,jk) - zhml(ji,jj) ) / zhml(ji,jj) !ALMG to think about
-                  IF ( znd >= 0.0 ) THEN
-                     ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * ( 1.0 - EXP( -10.0 * znd**2 ) )
-                     ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * ( 1.0 - EXP( -10.0 * znd**2 ) )
-                  ELSE
-                     ghamu(ji,jj,jk) = 0._wp
-                     ghamv(ji,jj,jk) = 0._wp
-                  ENDIF
-               END DO
-            ENDIF
-         END DO
-      END DO
+      DO_2D_00_00
+         IF ( lconv(ji,jj) ) THEN
+            DO jk = 2, ibld(ji,jj)
+               znd = ( gdepw(ji,jj,jk,Kmm) - zhml(ji,jj) ) / zhml(ji,jj) !ALMG to think about
+               IF ( znd >= 0.0 ) THEN
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * ( 1.0 - EXP( -30.0 * znd**2 ) )
+                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * ( 1.0 - EXP( -30.0 * znd**2 ) )
+               ELSE
+                  ghamu(ji,jj,jk) = 0._wp
+                  ghamv(ji,jj,jk) = 0._wp
+               ENDIF
+            END DO
+         ELSE
+            DO jk = 2, ibld(ji,jj)
+               znd = ( gdepw(ji,jj,jk,Kmm) - zhml(ji,jj) ) / zhml(ji,jj) !ALMG to think about
+               IF ( znd >= 0.0 ) THEN
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * ( 1.0 - EXP( -10.0 * znd**2 ) )
+                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * ( 1.0 - EXP( -10.0 * znd**2 ) )
+               ELSE
+                  ghamu(ji,jj,jk) = 0._wp
+                  ghamv(ji,jj,jk) = 0._wp
+               ENDIF
+            END DO
+         ENDIF
+      END_2D
 
        IF(ln_dia_osm) THEN
@@ -938,46 +898,42 @@
        ! Temporary fix to avoid instabilities when zdb_bl becomes very very small
        zsc_uw_1 = 0._wp ! 50.0 * zla**(8.0/3.0) * zustar**2 * zhbl / ( zdb_bl + epsln )
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
-                DO jk= 2, ibld(ji,jj)
-                   znd = gdepw_n(ji,jj,jk) / zhbl(ji,jj)
-                   ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zdiffut(ji,jj,jk) * zdtdz_pyc(ji,jj,jk)
-                   ghams(ji,jj,jk) = ghams(ji,jj,jk) + zdiffut(ji,jj,jk) * zdsdz_pyc(ji,jj,jk)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zviscos(ji,jj,jk) * zdudz_pyc(ji,jj,jk)
-                   ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zsc_uw_1(ji,jj) * ( 1.0 - znd )**(7.0/4.0) * zdbdz_pyc(ji,jj,jk)
-                   ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zviscos(ji,jj,jk) * zdvdz_pyc(ji,jj,jk)
-                END DO
-             END IF
-          END DO
-       END DO
+       DO_2D_00_00
+          IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
+             DO jk= 2, ibld(ji,jj)
+                znd = gdepw(ji,jj,jk,Kmm) / zhbl(ji,jj)
+                ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zdiffut(ji,jj,jk) * zdtdz_pyc(ji,jj,jk)
+                ghams(ji,jj,jk) = ghams(ji,jj,jk) + zdiffut(ji,jj,jk) * zdsdz_pyc(ji,jj,jk)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zviscos(ji,jj,jk) * zdudz_pyc(ji,jj,jk)
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zsc_uw_1(ji,jj) * ( 1.0 - znd )**(7.0/4.0) * zdbdz_pyc(ji,jj,jk)
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zviscos(ji,jj,jk) * zdvdz_pyc(ji,jj,jk)
+             END DO
+          END IF
+       END_2D
 
 ! Entrainment contribution.
 
-       DO jj=2, jpjm1
-          DO ji = 2, jpim1
-            IF ( lconv(ji,jj) .AND. ibld(ji,jj) + ibld_ext < mbkt(ji,jj)) THEN
-               DO jk = 1, imld(ji,jj) - 1
-                  znd=gdepw_n(ji,jj,jk) / zhml(ji,jj)
-                  ! ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth_ent(ji,jj) * znd
-                  ! ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws_ent(ji,jj) * znd
-                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zuw_bse(ji,jj) * znd
-                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zvw_bse(ji,jj) * znd
-               END DO
-               DO jk = imld(ji,jj), ibld(ji,jj)
-                  znd = -( gdepw_n(ji,jj,jk) - zhml(ji,jj) ) / zdh(ji,jj)
-                  ! ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth_ent(ji,jj) * ( 1.0 + znd )
-                  ! ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws_ent(ji,jj) * ( 1.0 + znd )
-                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zuw_bse(ji,jj) * ( 1.0 + znd )
-                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zvw_bse(ji,jj) * ( 1.0 + znd )
-                END DO
-             ENDIF
-
-             ghamt(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
-             ghams(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
-             ghamu(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
-             ghamv(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
-          END DO       ! ji loop
-       END DO          ! jj loop
+       DO_2D_00_00
+          IF ( lconv(ji,jj) .AND. ibld(ji,jj) + ibld_ext < mbkt(ji,jj)) THEN
+             DO jk = 1, imld(ji,jj) - 1
+                znd=gdepw(ji,jj,jk,kmm) / zhml(ji,jj)
+                ! ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth_ent(ji,jj) * znd
+                ! ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws_ent(ji,jj) * znd
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zuw_bse(ji,jj) * znd
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zvw_bse(ji,jj) * znd
+             END DO
+             DO jk = imld(ji,jj), ibld(ji,jj)
+                znd = -( gdepw(ji,jj,jk,kmm) - zhml(ji,jj) ) / zdh(ji,jj)
+                ! ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth_ent(ji,jj) * ( 1.0 + znd )
+                ! ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws_ent(ji,jj) * ( 1.0 + znd )
+                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zuw_bse(ji,jj) * ( 1.0 + znd )
+                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zvw_bse(ji,jj) * ( 1.0 + znd )
+             END DO
+          ENDIF
+
+          ghamt(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
+          ghams(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
+          ghamu(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
+          ghamv(ji,jj,ibld(ji,jj)+ibld_ext) = 0._wp
+       END_2D
 
        IF(ln_dia_osm) THEN
@@ -1001,13 +957,11 @@
        ! rotate non-gradient velocity terms back to model reference frame
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             DO jk = 2, ibld(ji,jj)
-                ztemp = ghamu(ji,jj,jk)
-                ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * zcos_wind(ji,jj) - ghamv(ji,jj,jk) * zsin_wind(ji,jj)
-                ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * zcos_wind(ji,jj) + ztemp * zsin_wind(ji,jj)
-             END DO
+       DO_2D_00_00
+          DO jk = 2, ibld(ji,jj)
+             ztemp = ghamu(ji,jj,jk)
+             ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * zcos_wind(ji,jj) - ghamv(ji,jj,jk) * zsin_wind(ji,jj)
+             ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * zcos_wind(ji,jj) + ztemp * zsin_wind(ji,jj)
           END DO
-       END DO
+       END_2D
 
        IF(ln_dia_osm) THEN
@@ -1019,40 +973,30 @@
 ! KPP-style Ri# mixing
        IF( ln_kpprimix) THEN
-          DO jk = 2, jpkm1           !* Shear production at uw- and vw-points (energy conserving form)
-             DO jj = 1, jpjm1
-                DO ji = 1, jpim1   ! vector opt.
-                   z3du(ji,jj,jk) = 0.5 * (  un(ji,jj,jk-1) -  un(ji  ,jj,jk) )   &
-                        &                 * (  ub(ji,jj,jk-1) -  ub(ji  ,jj,jk) ) * wumask(ji,jj,jk) &
-                        &                 / (  e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) )
-                   z3dv(ji,jj,jk) = 0.5 * (  vn(ji,jj,jk-1) -  vn(ji,jj  ,jk) )   &
-                        &                 * (  vb(ji,jj,jk-1) -  vb(ji,jj  ,jk) ) * wvmask(ji,jj,jk) &
-                        &                 / (  e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) )
-                END DO
+          DO_3D_10_10( 2, jpkm1 )
+             z3du(ji,jj,jk) = 0.5 * (  uu(ji,jj,jk-1,Kmm) -  uu(ji  ,jj,jk,Kmm) )   &
+                  &                 * (  uu(ji,jj,jk-1,Kbb) -  uu(ji  ,jj,jk,Kbb) ) * wumask(ji,jj,jk) &
+                  &                 / (  e3uw(ji,jj,jk,Kmm) * e3uw(ji,jj,jk,Kbb) )
+             z3dv(ji,jj,jk) = 0.5 * (  vv(ji,jj,jk-1,Kmm) -  vv(ji,jj  ,jk,Kmm) )   &
+                  &                 * (  vv(ji,jj,jk-1,Kbb) -  vv(ji,jj  ,jk,Kbb) ) * wvmask(ji,jj,jk) &
+                  &                 / (  e3vw(ji,jj,jk,Kmm) * e3vw(ji,jj,jk,Kbb) )
+          END_3D
+      !
+         DO_3D_00_00( 2, jpkm1 )
+            !                                          ! shear prod. at w-point weightened by mask
+            zesh2  =  ( z3du(ji-1,jj,jk) + z3du(ji,jj,jk) ) / MAX( 1._wp , umask(ji-1,jj,jk) + umask(ji,jj,jk) )   &
+               &    + ( z3dv(ji,jj-1,jk) + z3dv(ji,jj,jk) ) / MAX( 1._wp , vmask(ji,jj-1,jk) + vmask(ji,jj,jk) )
+            !                                          ! local Richardson number
+            zri   = MAX( rn2b(ji,jj,jk), 0._wp ) / MAX(zesh2, epsln)
+            zfri =  MIN( zri / rn_riinfty , 1.0_wp )
+            zfri  = ( 1.0_wp - zfri * zfri )
+            zrimix(ji,jj,jk)  =  zfri * zfri  * zfri * wmask(ji, jj, jk)
+         END_3D
+
+          DO_2D_00_00
+             DO jk = ibld(ji,jj) + 1, jpkm1
+                zdiffut(ji,jj,jk) = zrimix(ji,jj,jk)*rn_difri
+                zviscos(ji,jj,jk) = zrimix(ji,jj,jk)*rn_difri
              END DO
-          END DO
-      !
-         DO jk = 2, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = 2, jpim1   ! vector opt.
-                  !                                          ! shear prod. at w-point weightened by mask
-                  zesh2  =  ( z3du(ji-1,jj,jk) + z3du(ji,jj,jk) ) / MAX( 1._wp , umask(ji-1,jj,jk) + umask(ji,jj,jk) )   &
-                     &    + ( z3dv(ji,jj-1,jk) + z3dv(ji,jj,jk) ) / MAX( 1._wp , vmask(ji,jj-1,jk) + vmask(ji,jj,jk) )
-                  !                                          ! local Richardson number
-                  zri   = MAX( rn2b(ji,jj,jk), 0._wp ) / MAX(zesh2, epsln)
-                  zfri =  MIN( zri / rn_riinfty , 1.0_wp )
-                  zfri  = ( 1.0_wp - zfri * zfri )
-                  zrimix(ji,jj,jk)  =  zfri * zfri  * zfri * wmask(ji, jj, jk)
-                END DO
-             END DO
-          END DO
-
-          DO jj = 2, jpjm1
-             DO ji = 2, jpim1
-                DO jk = ibld(ji,jj) + 1, jpkm1
-                   zdiffut(ji,jj,jk) = zrimix(ji,jj,jk)*rn_difri
-                   zviscos(ji,jj,jk) = zrimix(ji,jj,jk)*rn_difri
-                END DO
-             END DO
-          END DO
+          END_2D
 
        END IF ! ln_kpprimix = .true.
@@ -1060,11 +1004,9 @@
 ! KPP-style set diffusivity large if unstable below BL
        IF( ln_convmix) THEN
-          DO jj = 2, jpjm1
-             DO ji = 2, jpim1
-                DO jk = ibld(ji,jj) + 1, jpkm1
-                  IF(  MIN( rn2(ji,jj,jk), rn2b(ji,jj,jk) ) <= -1.e-12 ) zdiffut(ji,jj,jk) = rn_difconv
-                END DO
+          DO_2D_00_00
+             DO jk = ibld(ji,jj) + 1, jpkm1
+               IF(  MIN( rn2(ji,jj,jk), rn2b(ji,jj,jk) ) <= -1.e-12 ) zdiffut(ji,jj,jk) = rn_difconv
              END DO
-          END DO
+          END_2D
        END IF ! ln_convmix = .true.
 
@@ -1072,41 +1014,39 @@
  
        IF ( ln_osm_mle ) THEN  ! set up diffusivity and non-gradient mixing
-          DO jj = 2 , jpjm1
-             DO ji = 2, jpim1
-                IF ( lconv(ji,jj) .AND. mld_prof(ji,jj) - ibld(ji,jj) > 1 ) THEN ! MLE mmixing extends below the OSBL.
-            ! Calculate MLE flux profiles
-                   ! DO jk = 1, mld_prof(ji,jj)
-                   !    znd = - gdepw_n(ji,jj,jk) / MAX(zhmle(ji,jj),epsln)
-                   !    ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + &
-                   !         & zwt_fk(ji,jj) * ( 1.0 - ( 2.0 * znd + 1.0 )**2 ) * ( 1.0 + r5_21 * ( 2.0 * znd + 1.0 )**2 )
-                   !    ghams(ji,jj,jk) = ghams(ji,jj,jk) + &
-                   !         & zws_fk(ji,jj) * ( 1.0 - ( 2.0 * znd + 1.0 )**2 ) * ( 1.0 + r5_21 * ( 2.0 * znd + 1.0 )**2 )
-                   ! END DO
-            ! Calculate MLE flux contribution from surface fluxes
-                   DO jk = 1, ibld(ji,jj)
-                     znd = gdepw_n(ji,jj,jk) / MAX(zhbl(ji,jj),epsln)
-                     ghamt(ji,jj,jk) = ghamt(ji,jj,jk) - zwth0(ji,jj) * ( 1.0 - znd )
-                     ghams(ji,jj,jk) = ghams(ji,jj,jk) - zws0(ji,jj) * ( 1.0 - znd )
-                    END DO
-                    DO jk = 1, mld_prof(ji,jj)
-                      znd = gdepw_n(ji,jj,jk) / MAX(zhmle(ji,jj),epsln)
-                      ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth0(ji,jj) * ( 1.0 - znd )
-                      ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws0(ji,jj) * ( 1.0 -znd )
-                    END DO
-            ! Viscosity for MLEs
-                    DO jk = ibld(ji,jj), mld_prof(ji,jj)
-                      zdiffut(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), zdiff_mle(ji,jj) )
-                    END DO
-            ! Iterate to find approx vertical index for depth 1.1*zhmle(ji,jj)
-                    jl = MIN(mld_prof(ji,jj) + 2, mbkt(ji,jj))
-                    jl = MIN( MAX(INT( 0.1 * zhmle(ji,jj) / e3t_n(ji,jj,jl)), 2 ) + mld_prof(ji,jj), mbkt(ji,jj))
-                    DO jk = mld_prof(ji,jj),  jl
-                       zdiffut(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), zdiff_mle(ji,jj) * &
-                            & ( gdepw_n(ji,jj,jk) - gdepw_n(ji,jj,jl) ) / &
-                            & ( gdepw_n(ji,jj,mld_prof(ji,jj)) - gdepw_n(ji,jj,jl) - epsln))
-                    END DO
-                ENDIF
-            END DO
-          END DO
+          DO_2D_00_00
+             IF ( lconv(ji,jj) .AND. mld_prof(ji,jj) - ibld(ji,jj) > 1 ) THEN ! MLE mmixing extends below the OSBL.
+         ! Calculate MLE flux profiles
+                ! DO jk = 1, mld_prof(ji,jj)
+                !    znd = - gdepw(ji,jj,jk, Kmm ) / MAX(zhmle(ji,jj),epsln)
+                !    ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + &
+                !         & zwt_fk(ji,jj) * ( 1.0 - ( 2.0 * znd + 1.0 )**2 ) * ( 1.0 + r5_21 * ( 2.0 * znd + 1.0 )**2 )
+                !    ghams(ji,jj,jk) = ghams(ji,jj,jk) + &
+                !         & zws_fk(ji,jj) * ( 1.0 - ( 2.0 * znd + 1.0 )**2 ) * ( 1.0 + r5_21 * ( 2.0 * znd + 1.0 )**2 )
+                ! END DO
+         ! Calculate MLE flux contribution from surface fluxes
+                DO jk = 1, ibld(ji,jj)
+                  znd = gdepw(ji,jj,jk, Kmm ) / MAX(zhbl(ji,jj),epsln)
+                  ghamt(ji,jj,jk) = ghamt(ji,jj,jk) - zwth0(ji,jj) * ( 1.0 - znd )
+                  ghams(ji,jj,jk) = ghams(ji,jj,jk) - zws0(ji,jj) * ( 1.0 - znd )
+                 END DO
+                 DO jk = 1, mld_prof(ji,jj)
+                   znd = gdepw(ji,jj,jk, Kmm ) / MAX(zhmle(ji,jj),epsln)
+                   ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zwth0(ji,jj) * ( 1.0 - znd )
+                   ghams(ji,jj,jk) = ghams(ji,jj,jk) + zws0(ji,jj) * ( 1.0 -znd )
+                 END DO
+         ! Viscosity for MLEs
+                 DO jk = ibld(ji,jj), mld_prof(ji,jj)
+                   zdiffut(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), zdiff_mle(ji,jj) )
+                 END DO
+         ! Iterate to find approx vertical index for depth 1.1*zhmle(ji,jj)
+                 jl = MIN(mld_prof(ji,jj) + 2, mbkt(ji,jj))
+                 jl = MIN( MAX(INT( 0.1 * zhmle(ji,jj) / e3t(ji,jj,jl, Kmm ) ), 2 ) + mld_prof(ji,jj), mbkt(ji,jj))
+                 DO jk = mld_prof(ji,jj),  jl
+                    zdiffut(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), zdiff_mle(ji,jj) * &
+                         & ( gdepw(ji,jj,jk, Kmm ) - gdepw(ji,jj,jl, Kmm ) ) / &
+                         & ( gdepw(ji,jj,mld_prof(ji,jj), Kmm ) - gdepw(ji,jj,jl, Kmm ) - epsln))
+                 END DO
+             ENDIF
+          END_2D
        ENDIF
 
